// MFC60Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC60.h"
#include "MFC60Dlg.h"
#include "amldatasender.h"
#include "RichUtilBase.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CMFC60Dlg::CMFC60Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC60Dlg::IDD, pParent)
	,m_wndHyperLink(TEXT("http:\\www.amlpages.com"))
{
	//{{AFX_DATA_INIT(CMFC60Dlg)
	m_nFormat = ADS_FORMAT_PLAINTEXT;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC60Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFC60Dlg)
	DDX_Control(pDX, IDC_RICHEDIT, m_rich);
	DDX_Control(pDX, IDC_STATIC_HYPERLINK, m_wndHyperLink);
	DDX_CBIndex(pDX, IDC_COMBO_TYPE, m_nFormat);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFC60Dlg, CDialog)
	//{{AFX_MSG_MAP(CMFC60Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_LAUNCH_AMLPAGES, OnButtonLaunchAmlpages)
	ON_BN_CLICKED(IDC_BUTTON_SEND_TEXT, OnButtonSendText)
	ON_WM_CTLCOLOR()
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_BUTTON_SAVE_CB_AS_PLAIN_TEXT, OnButtonSaveCbAsPlainText)
	ON_BN_CLICKED(IDC_BUTTON_SAVE_CB_AS_HTML, OnButtonSaveCbAsHtml)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CMFC60Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFC60Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

static
bool CreateAmlDataSender(IIAmlDataSender& ds)
{
	COleException e;
	const BOOL b=ds.CreateDispatch(TEXT("AmlDataSender.IAmlDataSender.1"),&e);
	if (!b) {
		CString s;
		VERIFY(e.GetErrorMessage(s.GetBufferSetLength(MAX_PATH+1),MAX_PATH));
		s.ReleaseBuffer();
		s+=TEXT("\n\n AmlDataSender.dll     COM-   Windows.\n  -> regsvr32.exe ___AmlDataSender.dll");
		AfxMessageBox(s,MB_ICONEXCLAMATION);
	}

	return TRUE==b;
}

void CMFC60Dlg::OnButtonLaunchAmlpages() 
{
	// Aml Pages
	IIAmlDataSender ds;
	//  COM
	if (CreateAmlDataSender(ds)) {
		//
		const BOOL b=ds.LaunchAmlPages();
		if (b)
			AfxMessageBox(IDS_STARTSUCCESS);
		else
			AfxMessageBox(IDS_STARTFAIL,MB_ICONEXCLAMATION);
		ds.ReleaseDispatch();
	}
}

BOOL CMFC60Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_wndHyperLink.SetCursor(m_wndHyperLink.GetCursor());

	CString s;
	s.LoadString(IDS_HELLO);
	m_rich.SetWindowText(s);

	CHARFORMAT cf;
	cf.cbSize=sizeof(cf);
	cf.dwMask=CFM_BOLD|CFM_ITALIC|CFM_UNDERLINE;
	cf.dwEffects=CFE_ITALIC|CFE_BOLD|CFE_UNDERLINE;

	m_rich.SendMessage(EM_SETCHARFORMAT,SCF_ALL|SCF_DEFAULT,(LPARAM)&cf);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMFC60Dlg::OnButtonSendText() 
{
	IIAmlDataSender ds; 
	//  COM
	if (CreateAmlDataSender(ds)) {
		UpdateData(TRUE);
		// 
		CString s;
		if (ADS_FORMAT_RTFTEXT!=m_nFormat)
			s=RichUtilBase::TextOut(m_rich,false,true,false,NULL,0);
		else
			s=RichUtilBase::TextOut(m_rich,false,false,false,NULL,0);

		const BOOL b=ds.SendText(s,m_nFormat,15);
		if (b) {// 
			AfxMessageBox(IDS_TEXTSENDED);
		}
		else {//  
			CString s;
			//  ,   AmlDataSender.tlb
			s.Format(IDS_CANTSEND,ds.GetLastError());
			AfxMessageBox(s,MB_ICONEXCLAMATION);
		}
		ds.ReleaseDispatch();
	}
}

HBRUSH CMFC60Dlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	if ((CTLCOLOR_STATIC==nCtlColor) && (IDC_STATIC_HYPERLINK==pWnd->GetDlgCtrlID())) {
		pDC->SetTextColor(RGB(0,0,255));
	}	
	return hbr;
}


void CMFC60Dlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDown(nFlags, point);
	ReleaseCapture();
	SendMessage(WM_SYSCOMMAND,HTCAPTION|SC_MOVE);
}

void CMFC60Dlg::OnButtonSaveCbAsPlainText() 
{
	SaveCBAs(false);
	
}

void CMFC60Dlg::OnButtonSaveCbAsHtml() 
{
	SaveCBAs(false);
	
}

void CMFC60Dlg::SaveCBAs(const bool bAsHTML)
{
	IIAmlDataSender ds; 
	//  COM
	if (CreateAmlDataSender(ds)) {
		const BOOL b=bAsHTML ? ds.SendTextFromClipboardInHTMLFormat() : ds.SendTextFromClipboardInTextFormat();
		if (b) {// 
			AfxMessageBox(IDS_TEXTSENDED);
		}
		else {//  
			CString s;
			//  ,   AmlDataSender.tlb
			s.Format(IDS_CANTSEND,ds.GetLastError());
			AfxMessageBox(s,MB_ICONEXCLAMATION);
		}
		ds.ReleaseDispatch();
	}
}
