// WinAPI.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include "..\..\AmlDataSender.h"

#define MAX_LOADSTRING 100

struct CRect:public RECT {
	CRect() {
		memset((void*)this,0,sizeof(RECT));
	}

	CRect(int x,int y,int r,int b) {
		left=x;
		top=y;
		right=r;
		bottom=b;
	}
};

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE /*hPrevInstance*/,
                     LPSTR     /*lpCmdLine*/,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WINAPI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	CoInitialize(NULL);

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WINAPI);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	CoUninitialize();

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex={0};

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_WINAPI;
	wcex.lpszClassName	= szWindowClass;
	
	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
HWND CreateChildWindow(LPCTSTR lpszClassName, DWORD  dwStyle
					   ,LPCTSTR lpszText, const UINT nID, const CRect r
					   , HWND hwndParent)
{
	ASSERT(!IsBadStringPtr(lpszClassName,INFINITE));
	ASSERT(strlen(lpszClassName));
	dwStyle|=WS_VISIBLE|WS_CHILD|WS_TABSTOP;
	ASSERT(nID>0);
	ASSERT(IsWindow(hwndParent));

	const HWND hwndRet=CreateWindow(lpszClassName,lpszText,dwStyle
		,r.left,r.top,r.right-r.left,r.bottom-r.top,hwndParent,NULL,hInst,NULL);
	ASSERT(IsWindow(hwndRet));
	if (IsWindow(hwndRet))
		SetWindowLong(hwndRet,GWL_ID,nID);

	return hwndRet;
}

HWND CreateEdit(LPCTSTR lpszText, const UINT nID, const CRect r, HWND hwndParent)
{
	return CreateChildWindow("EDIT"
		,ES_MULTILINE|ES_WANTRETURN|WS_BORDER|ES_AUTOVSCROLL|WS_VSCROLL
		,lpszText,nID,r,hwndParent);	
}
 
HWND CreatePushButton(LPCTSTR lpszText, const UINT nID, const CRect  r, HWND hwndParent)
{
	return CreateChildWindow("BUTTON"
		,BS_PUSHBUTTON|WS_BORDER
		,lpszText,nID,r,hwndParent);
}

HWND CreateCombo(const UINT nID, const CRect  r, HWND hwndParent)
{
	const HWND hwnd=CreateChildWindow("COMBOBOX"
		,CBS_DROPDOWNLIST|CBS_HASSTRINGS|WS_VSCROLL
		,NULL,nID,r,hwndParent);

	SendMessage(hwnd,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"Save As Plain Text -   Plain Text");
	SendMessage(hwnd,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"Save As HTML Code -   HTML Text");
	SendMessage(hwnd,CB_ADDSTRING,0,(LPARAM)(LPCTSTR)"Save As RTF Text -   RTF Text");

	const int h=r.bottom-r.top;
	const int w=r.right-r.left;
	::SetWindowPos(hwnd,NULL,0,0,w,h*4,SWP_NOMOVE);
	SendMessage(hwnd,CB_SETCURSEL,0,0);
	return hwnd;
}

IIAmlDataSender* CreateAmlDataSenderObject()
{
	IIAmlDataSender* pUnk=NULL;
	const HRESULT hr=CoCreateInstance(CLSID_IAmlDataSender
		,NULL
		,CLSCTX_INPROC_SERVER
		,IID_IIAmlDataSender,(void**)&pUnk);
	ASSERT(S_OK==hr);

	return pUnk;
}

bool
OnLaunchAmlPages()
{
	bool bRet=false;
	IIAmlDataSender* pAmlDS=CreateAmlDataSenderObject();
	if (pAmlDS) {
		VARIANT_BOOL bSuccess=VARIANT_FALSE;
		const HRESULT hr=pAmlDS->LaunchAmlPages(&bSuccess);
		ASSERT(S_OK==hr);
		pAmlDS->Release();
		bRet=VARIANT_TRUE==bSuccess;
	}

	return bRet;
}

bool OnSendText(HWND hwnd)
{
	ASSERT(IsWindow(hwnd));

	const HWND hwndText=GetDlgItem(hwnd,ID_EDIT_TEXT);
	ASSERT(IsWindow(hwndText));
	
	const int nTextLen=GetWindowTextLength(hwndText);
	
	TCHAR* psz=new TCHAR[nTextLen+2];
	ASSERT(!IsBadWritePtr(psz,sizeof(TCHAR)*(nTextLen+2)));
	memset((void*)psz,0,sizeof(TCHAR)*(nTextLen+2));
	
	GetWindowText(hwndText,psz,nTextLen+1);

	bool bRet=false;
	IIAmlDataSender* pAmlDS=CreateAmlDataSenderObject();
	if (pAmlDS) {
		const int nLen = MultiByteToWideChar(CP_ACP, 0, psz,
			strlen(psz) ,NULL, NULL);
		
		const BSTR bstr = ::SysAllocStringLen(NULL, nLen);
		
		if (bstr) {
			MultiByteToWideChar(CP_ACP, 0, psz, strlen(psz),bstr, nLen);
			VARIANT_BOOL bSuccess=VARIANT_FALSE;

			const HWND hwndCheckAsHTML=GetDlgItem(hwnd,ID_CHECK_AS_HTML);

			ASSERT(IsWindow(hwndCheckAsHTML));
			const int nFormat=SendMessage(hwndCheckAsHTML,CB_GETCURSEL,0,0);

			HRESULT hr=pAmlDS->SendText(bstr
				,(ADS_FORMAT)nFormat
				,15
				,&bSuccess);

			pAmlDS->Release();
			
			if ((S_OK==hr) && (VARIANT_TRUE==bSuccess))
				bRet=true;
			
			SysFreeString(bstr);
		}//if (bstr ) {
	}//if (pAmlDS) {

	delete[] psz;
	return bRet;
}

LRESULT CommandProc(HWND hwnd, const UINT nID, WPARAM wParam, LPARAM lParam)
{
	switch(nID) {
	case ID_BUTTON_LAUNCHAMLPAGES:
		
		if (!OnLaunchAmlPages())
			MessageBox(hwnd,"   Aml Pages","",MB_ICONEXCLAMATION);
		else
			MessageBox(hwnd,"Aml Pages  ","",MB_ICONINFORMATION);
		break;
	case ID_BUTTON_SENDTEXT:
		OnSendText(hwnd);
		break;
	};

	return FALSE;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   if (CommandProc(hWnd,LOWORD(wParam),wParam,lParam))
					   return TRUE;
				   else
					   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			rt.top+=300;
			DrawText(hdc, szHello, strlen(szHello), &rt, DT_CENTER);
			EndPaint(hWnd, &ps);
			break;
		case WM_CREATE:
			{
			CRect r(10,10,160,30);
			CreatePushButton("LaunchAmlPages",ID_BUTTON_LAUNCHAMLPAGES,r,hWnd);
			r.left=170;
			r.right=330;
			CreatePushButton("SendText",ID_BUTTON_SENDTEXT,r,hWnd);
			r.left=10;
			r.top=50;
			r.bottom=70;
			r.right=330;
			CreateCombo(ID_CHECK_AS_HTML,r,hWnd);
			
			r.left=10;
			r.right=330;
			r.top=80;
			r.bottom=240;
			CreateEdit("Helllo from Aml Data Sender WinAPI Sample\r\n  Aml Data Sender WinAPI Sample\r\n\r\n     Aml Pages",ID_EDIT_TEXT,r,hWnd);
			}
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
